@ECHO OFF
REM -- DOS makefile for compiling the GBExtended library

CALL ..\configure.bat
CALL localconfigure.bat

IF DEFINED TARGET_INCLUDE_ROOT_DIR GOTO :ELSE1
  ECHO ### ERROR: configuration file not adapted - please edit it first ###
  GOTO :ENDIF1
:ELSE1
  ECHO ### GBExtended: making libary ###

  REM --------------------------------------
  REM --- commands and other definitions ---
  REM --------------------------------------
  SET compileCommand=CALL %TOOLS_DIR%\sdcc-compile -o %TARGET_OBJECT_DIR%
  SET compileCommand=%compileCommand% -s %TARGET_SOURCE_DIR%

  REM ** optimize multiplications and use hand-optimized assembler code **
  SET SDCC_USER_DEFINES=-DmulDivAreAvoided -DuseOptimizedCode
  REM ------------------------------------------------------------

  REM NOTE:
  REM modules with a --code 0 may be relocated to some bank 1..X
  REM modules without a --code go to bank 0 into the BASE segment

  %compileCommand% assertion
  %compileCommand% background
  %compileCommand% bugfix
  %compileCommand% dialog --code 0
  %compileCommand% font --code 0
  %compileCommand% font_rsc --code 0
  %compileCommand% hardware
  %compileCommand% joypad --code 0
  %compileCommand% map --code 0
  %compileCommand% mapanimation --code 0
  %compileCommand% mapcoordinate --code 0
  %compileCommand% mapview
  %compileCommand% midisong --code 0
  %compileCommand% palette
  %compileCommand% screen
  %compileCommand% set --code 0
  %compileCommand% sound
  %compileCommand% sprite --code 0
  %compileCommand% spriteanimation --code 0
  %compileCommand% string
  %compileCommand% tile
  %compileCommand% window --code 0

  ECHO === assembling profiler.s ===
  %SDCC_PATH%\bin\as-gbz80 -pog %TARGET_OBJECT_DIR%\profiler.o %TARGET_SOURCE_DIR%\profiler.s

  REM === cleanup ===
  %RM_PROGRAM% *.sym *.adb *.xxx *.asm >NUL 2>NUL
:ENDIF1
