	.MODULE profiler

	.GLOBL _Profiler_initialize
	.GLOBL _Profiler_finalize

	.AREA _DATA

_Profiler__st:
	.DS 30

	.AREA _BASE
__str_0:
	.ASCII "IN %totalclks%"
	.DB 0x00
__str_1:
	.ASCII "OUT %totalclks%"
	.DB 0x00

Profiler__hexDigitList:
	.ASCII "0123456789ABCDEF"

;; ----------------------------------------

_Profiler__putOutHalfByte::
	;; puts character representation of lower halfbyte in A
	;; into adress pointed by DE;  DE is incremented by 1
	PUSH	BC
	PUSH	HL
	AND	#0xF		; mask off high halfbyte
	LD	HL,#Profiler__hexDigitList
	LD	C,A
	XOR	A
	LD	B,A
	ADD	HL,BC
	LD	A,(HL)		; A = hexDigitList[value]
	LD	(DE),A		; *ptr++ = A
	INC	DE
	POP	HL
	POP	BC
	RET
	
;; ----------------------------------------

_Profiler__putOutByte::
	;; puts character representation of byte in A into adress
	;; pointed by DE and following; DE is incremented by 2
	PUSH	BC
	LD	B,A
	SWAP	A
	CALL	_Profiler__putOutHalfByte
	LD	A,B
	POP	BC
	CALL	_Profiler__putOutHalfByte
	RET

;; ----------------------------------------

_Profiler__putOutWord::
	;; puts character representation of word in BC into adress
	;; pointed by DE and following; DE is incremented by 4
	PUSH	AF
	LD	A,B
	CALL	_Profiler__putOutByte
	LD	A,C
	CALL	_Profiler__putOutByte
	POP	AF
	RET
	
;; ----------------------------------------

_Profiler__handleInterrupt::
	;; writes out profiling information to NO$GMB
	;; message file
	LD	HL,#__STR_0 	; write entry time (in clocks)
	PUSH	HL
	CALL	_DEBUG_write
	POP	HL

	LD	HL,#__Profiler_flag ; if (Profiler_flag == enter)
	LD	A,(HL)
	CP	A,#0x03
	JP	NZ,00101$	    ; then
	LD	HL,#__Profiler_pc   ;   Profiler_pc -= 3
	LD	A,(HL)
	SBC	#0x3
	LD	(HL+),A
	JR	NC,00100$
	DEC	(HL)
00100$: 
	LD	A,#0x3E		    ;  A = '>'
	JR	00102$
00101$:				    ; else
	LD	A,#0x3C		    ;  A = '<' 
00102$:				    ; endif 

	LD	DE,#_Profiler__st
	LD	(DE),A
	INC	DE
	LD	A,#0x20		    ; A = ' '
	LD	(DE),A
	INC	DE

	LD	HL,#__Profiler_pc+1 ; if (HIGH(Profiler_pc) <= 0x3F ||
	LD	A,(HL)		   ;     || HIGH(Profiler_pc) >= 0x80)
	CP	#0x80
	JR	NC,00103$
	CP	#0x40
	JR	NC,00104$	   ; then
00103$:
	XOR	A		   ;   bank = 0
	JR	00105$		   ; else
00104$:
	LD	A,(_Banking__currentBank) ;  bank = Banking__currentBank;
00105$:				   ; endif
	 
	CALL	_Profiler__putOutByte ; putOutByte(bank)

	LD	A,#0x3A		  ; A = ':'
	LD	(DE),A

	INC	DE
	LD	HL,#__Profiler_pc
	LD	A,(HL+)
	LD	C,A
	LD	A,(HL)
	LD	B,A
	CALL	_Profiler__putOutWord ; putOutWord(profile_pc)

	XOR	A
	LD	(DE),A
	LD	HL,#_Profiler__st
	PUSH	HL
	CALL	_DEBUG_write	; write formatted entry or exit address
	POP	HL

	LD	HL,#__STR_1 	; write exit time (in clocks)
	PUSH	HL
	CALL	_DEBUG_write
	POP	HL
	RET
	
;; ----------------------------------------

_Profiler_initialize::
	;; adds profiler message output to the interrupt handling for
	;; profiling reset
	LD	HL,#_Profiler__handleInterrupt
	PUSH	HL
	CALL	_add_PROF
	POP	HL
_Profiler_initialize_end::
	RET

;; ----------------------------------------

_Profiler_finalize::
	RET
_Profiler_finalize_end::
